Index: tmp/org.txm.cah.core/src/org/txm/cah/core/chartsengine/jfreechart/JFCCAHChartCreator.java
===================================================================
--- tmp/org.txm.cah.core/src/org/txm/cah/core/chartsengine/jfreechart/JFCCAHChartCreator.java	(revision 136)
+++ tmp/org.txm.cah.core/src/org/txm/cah/core/chartsengine/jfreechart/JFCCAHChartCreator.java	(revision 137)
@@ -5,11 +5,12 @@
 import org.txm.chartsengine.jfreechart.core.JFCChartCreator;
 
 /**
+ * JFC CAH chart creator.
  * 
  * @author mdecorde
+ * @author sjacquot
  * 
- * TODO: not done
- *
+ * 
  */
 public class JFCCAHChartCreator extends JFCChartCreator {
 
@@ -20,6 +21,8 @@
 	@Override
 	public JFreeChart createChart(Object resultData, String preferencesNode) {
 
+		System.err.println("JFCCAHChartCreator.createChart(): not yet implemented.");
+		
 		final CAH cah = (CAH) resultData;
 		
 		
@@ -27,7 +30,15 @@
 		
 	}
 
+	
+	@Override
+	// FIXME: to not load the chart creator, to remove when implemented 
+	public Class getChartsEngineClass() {
+		return null;
+	}
 
+	
+
 	@Override
 	public Class getResultDataClass() {
 		return CAH.class;
@@ -36,7 +47,659 @@
 
 
 
+	
+	// FIXME: old version with bar plot renderer
+//	@Override
+//	public JFreeChart createCAH2dChart(CAH cah) {
+//
+//
+//		JFreeChart chart = null;
+//
+//		// Creating the data set from the result
+//		DefaultCategoryDataset dataset = new DefaultCategoryDataset();
+//		String category = "cluster ";
+//
+//
+//
+//		int[] clusterNumbers = cah.getClusterNumbers();
+//		String[] rowNames = cah.getClusterRowNames();
+//		String[] orderedRowNames = cah.getClusterOrderedRowNames();
+//		double[] clusterHeights = cah.getClusterTreeHeights();
+//		double[][] clusterMerges = cah.getClusterTreeMerges();
+//		double[][] clusterCoords = cah.getClusterCoords();
+//
+//		double[] yValuesByOrderedRowNames = new double[rowNames.length];
+//		double[] clusterNumbersValuesByOrderedRowNames = new double[rowNames.length];
+//
+//
+//
+//		// FIXME: Sort the cluster numbers in reverse order
+////			Arrays.sort(clusterNumbers);
+////			ArrayUtils.reverse(clusterNumbers);
+////			System.out.println(Arrays.toString(clusterNumbers));
+//
+//
+//		// FIXME: tests row names
+//		//System.err.println("JFCChartsEngine.createCAH2dChart(): cluster row names: \t\t" + Arrays.toString(rowNames));
+//
+//		// FIXME: tests ordered row names
+//		//System.err.println("JFCChartsEngine.createCAH2dChart(): cluster ordered row names: \t" + Arrays.toString(orderedRowNames));
+//
+//		// FIXME: tests, ordered cluster numbers
+//		//System.err.println("JFCChartsEngine.createCAH2dChart(): cluster numbers: \t\t" + Arrays.toString(clusterNumbers));
+//
+//		// FIXME: tests, cluster tree merges
+//		//System.err.println("JFCChartsEngine.createCAH2dChart(): cluster tree merges: \t\t" + Arrays.toString(clusterMerges));
+//
+//		// FIXME: tests, heights
+////		System.err.println("JFCChartsEngine.createCAH2dChart(): cluster heights: \t\t" + Arrays.toString(clusterHeights));
+//
+//
+//		// FIXME: tests
+//		System.err.println("JFCChartsEngine.createCAH2dChart(): tests: \t\t" + Arrays.toString(cah.getInertiaGains()));
+//
+//
+//
+//		System.out.println("JFCChartsEngine.createCAH2dChart() cluster heights count: " + clusterHeights.length);
+//		for(int i = 0; i < clusterHeights.length; i++) {
+//			System.out.println("JFCChartsEngine.createCAH2dChart() cluster height: " + new DecimalFormat("0.00000000000000000").format(clusterHeights[i]));
+//		}
+//
+////
+////		String[] clusterUnorderedRowNames = cah.getClusterRowNames();
+////		for(int i = 0; i < clusterUnorderedRowNames.length; i++) {
+////			System.out.println("JFCChartsEngine.createCAH2dChart() unordered row names " + i + " : " + clusterUnorderedRowNames[i]);
+////		}
+//
+//		// Parse the merge pairs
+//		// A negative number in the FactoMineR tree merge table means a singleton
+//		for (int i = 0 ; i < clusterMerges.length ; i++) {
+//
+//			// FIXME: debug
+//			//for (int j = 0 ; j < clusterMerges.length ; j++) {
+//				System.err.println("JFCChartsEngine.createCAH2dChart(): cluster tree merges: \t\t" + Arrays.toString(clusterMerges[i]));
+//				System.err.println("JFCChartsEngine.createCAH2dChart(): row names: \t\t" + rowNames[(int) Math.abs(clusterMerges[i][0]) - 1] + " | " + rowNames[(int) Math.abs(clusterMerges[i][1]) - 1]);
+//
+//
+//			//}
+//
+//			// Leaves pair
+//			if(clusterMerges[i][0] < 0)	{
+//
+//				//System.err.print("JFCChartsEngine.createCAH2dChart(): merging: " + rowNames[(int) Math.abs(clusterMerge[i][0]) - 1]);
+//
+//				// Put the height in the ordered by names values table
+//				for(int j = 0; j < orderedRowNames.length; j++) {
+//					if(orderedRowNames[j].equals(rowNames[(int) Math.abs(clusterMerges[i][0]) - 1]))	{
+//						yValuesByOrderedRowNames[j] = clusterHeights[i];
+//						//clusterNumbersValuesByOrderedRowNames[j] = clusterNumbers[(int) Math.abs(clusterMerge[i][0]) - 1];
+//					}
+//				}
+//
+//			}
+//			// Non-singleton
+////				else	{
+////					//System.err.print("JFCChartsEngine.createCAH2dChart(): merging aggregation: " +  clusterMerge[i][0]);
+////				}
+//
+//			// Leaves pair
+//			if(clusterMerges[i][1] < 0)	{
+//				//System.err.print(" with: " + rowNames[(int) Math.abs(clusterMerge[i][1]) - 1]);
+//
+//				// Put the height in the ordered by names values table
+//				for(int j = 0; j < orderedRowNames.length; j++) {
+//					if(orderedRowNames[j].equals(rowNames[(int) Math.abs(clusterMerges[i][1]) - 1]))	{
+//						yValuesByOrderedRowNames[j] = clusterHeights[i];
+//						//clusterNumbersValuesByOrderedRowNames[j] = clusterNumbers[(int) Math.abs(clusterMerge[i][1]) - 1];
+//					}
+//
+//				}
+//
+//			}
+//			// Non-singleton
+////				else	{
+////					//System.err.print(" with aggregation: " + clusterMerge[i][1]);
+////				}
+//
+//			//System.err.println(" and height: " + clusterHeights[i] + " as aggregation: " + (i + 1));
+//
+//		}
+//
+//
+//		//
+////		for (int i = 0 ; i <  cah.getClusterTreeMerges().length; i++) {
+////			System.err.println("JFCChartsEngine.createCAH2dChart() merges : ");
+////			for(int j = 0; j < cah.getClusterTreeMerges()[i].length; j++) {
+////				System.err.print(" : " + cah.getClusterTreeMerges()[i][j]);
+////			}
+////		}
+//
+//
+//
+////		ArrayList<Double> middlePoints = cah.getClusterTreeMiddlePoints();
+////
+////		for (int i = 0 ; i <  middlePoints.size(); i++) {
+////			System.err.println("JFCChartsEngine.createCAH2dChart() middle points X: " + middlePoints.get(i));
+////		}
+//
+//
+//
+////		for (int i = 0 ; i < cah.getClusterCoords().length ; i++) {
+////			for(int j = 0; j < cah.getClusterCoords()[i].length; j++) {
+////				//System.err.println("JFCChartsEngine.createCAH2dChart(): " + cah.getClusterCoords()[i][j]);
+////				dataset.setValue(cah.getClusterCoords()[i][j], category + clusterNumbers[i], rownames[i]);
+////			}
+////		}
+//
+//
+//
+//		// Create chart title
+//		String title = "title";
+//		String xAxisLabel = "Column";
+//		if(!cah.isColumnsComputing())	{
+//			xAxisLabel = "Row";
+//		}
+//
+//
+//
+//		// Create the data set
+//		// FIXME: bar plot test
+////		for(int i = 0; i < yValuesByOrderedRowNames.length; i++) {
+////			//dataset.setValue(yValuesByOrderedRowNames[i], category + clusterNumbers[clusterNumbers.length - 1 - i], orderedRowNames[i]);
+////
+////
+////			dataset.setValue(yValuesByOrderedRowNames[i], category + clusterNumbers[yValuesByOrderedRowNames.length - 1 - i], orderedRowNames[i]);
+////			//dataset.setValue(yValuesByOrderedRowNames[i], category + clusterNumbers[i], orderedRowNames[i]);
+////
+////			//dataset.setValue(yValuesByOrderedRowNames[i], category + clusterNumbersValuesByOrderedRowNames[i], orderedRowNames[i]);
+////		}
+////
+////		// Create the chart
+////        chart = this.createCategoryBarChart(dataset, title, xAxisLabel, "Height", false, false, false);
+////        ((IItemSelectionRenderer) chart.getCategoryPlot().getRenderer()).setChartType(ChartsEngine.CHART_TYPE_CAH_2D);
+////
+////        // Draw tree
+////        for(int j = 0; j < chart.getCategoryPlot().getDataset().getColumnCount() - 1; j++) {
+////			//System.err.println("JFCChartsEngine.createCAH2dChart(): " + chart.getCategoryPlot().getDataset().getColumnKey(j));
+////
+////
+////        	// Non-singleton pairs lines
+////			if(yValuesByOrderedRowNames[j] == yValuesByOrderedRowNames[j + 1])	{
+////				chart.getCategoryPlot().addAnnotation(new CategoryLineAnnotation(chart.getCategoryPlot().getDataset().getColumnKey(j), yValuesByOrderedRowNames[j],
+////						chart.getCategoryPlot().getDataset().getColumnKey(j + 1), yValuesByOrderedRowNames[j + 1], Color.red, new BasicStroke(2.0f)));
+////			}
+////
+////
+////			//chart.getCategoryPlot().addAnnotation(new Cate
+////
+////
+////
+////		}
+//
+//
+//
+//		// Create the data set
+//		// FIXME: step chart test
+////		for(int i = 0; i < yValuesByOrderedRowNames.length - 1; i++) {
+////			if(yValuesByOrderedRowNames[i] == yValuesByOrderedRowNames[i + 1])	{
+////				dataset.setValue(yValuesByOrderedRowNames[i], category + clusterNumbers[yValuesByOrderedRowNames.length - 1 - i], orderedRowNames[i]);
+////			}
+////		}
+//////		dataset.addValue(0, "test", "truc 1");
+//////		dataset.addValue(0.5, "test", "truc 1");
+//////		dataset.addValue(0.9, "test", "truc 1");
+////		// Create the chart
+////        chart = this.createCategoryStepChart(dataset, title, xAxisLabel, "Height", false, false);
+////        ((IItemSelectionRenderer) chart.getCategoryPlot().getRenderer()).setChartType(ChartsEngine.CHART_TYPE_CAH_2D);
+//
+//
+//		// Create the data set
+//		// FIXME: XY category bar chart test
+//		XYSeriesCollection dataset2 = new XYSeriesCollection();
+//
+//		// Last tree level (leaves level)
+//		XYSeries series = new XYSeries("leaves");
+//		for(int i = 0; i < yValuesByOrderedRowNames.length - 1; i++) {
+//			series.add(i, 0);
+//			series.add(i, yValuesByOrderedRowNames[i]);
+//			if(yValuesByOrderedRowNames[i] == yValuesByOrderedRowNames[i + 1])	{
+//				series.add(i + 1, yValuesByOrderedRowNames[i]);
+//				series.add(i + 1, 0);
+//			}
+//			else	{
+//				series.add(i + 1, null);
+//			}
+//		}
+//		dataset2.addSeries(series);
+//
+//
+//		// Link singletons to non singleton
+//		series = new XYSeries("singleton to non singleton links");
+//		for(int i = clusterHeights.length; i >= 0; i--) {
+//
+//			// Skip non singletons case
+//			if(i > 3 && yValuesByOrderedRowNames[i] == yValuesByOrderedRowNames[i - 1] && yValuesByOrderedRowNames[i - 2] == yValuesByOrderedRowNames[i - 3])	{
+//				continue;
+//			}
+//
+//			// Link singletons to non singleton
+//			if(i > 1 && yValuesByOrderedRowNames[i] == yValuesByOrderedRowNames[i - 1] && yValuesByOrderedRowNames[i - 1] != yValuesByOrderedRowNames[i - 2]) {
+//				series.add(i - 0.5, yValuesByOrderedRowNames[i - 2]);
+//				series.add(i - 0.5, yValuesByOrderedRowNames[i]);
+//				series.add(i - 0.5, null);
+//				series.add(i - 2, yValuesByOrderedRowNames[i - 2]);
+//			}
+//		}
+//		dataset2.addSeries(series);
+//
+//		// Link singletons to newly created pairs
+//		series = new XYSeries("singleton to newly created pairs");
+//		for(int i = clusterHeights.length; i >= 0; i--) {
+//
+//			// Skip non singletons case
+//			if(i > 0 && yValuesByOrderedRowNames[i] == yValuesByOrderedRowNames[i - 1])	{
+//				series.add(i, null);
+//				continue;
+//			}
+//
+//			// Link singletons to newly created pairs
+//			if(i < clusterHeights.length - 1 && yValuesByOrderedRowNames[i] != yValuesByOrderedRowNames[i + 1]
+//					&& yValuesByOrderedRowNames[i + 1] != yValuesByOrderedRowNames[i + 2]
+//
+////						&& i > 1 &&
+//
+//							) {
+//
+//				series.add(i, null);
+//
+//				series.add(i, yValuesByOrderedRowNames[i]);
+//
+//				series.add(i + 1.75, yValuesByOrderedRowNames[i]);
+//				series.add(i + 1.75, yValuesByOrderedRowNames[i + 1]);
+//
+//
+//				//series.add(i - 2, yValuesByOrderedRowNames[i - 2]);
+//			}
+//		}
+//		dataset2.addSeries(series);
+//
+//
+//
+//		// Link singletons; test 2
+////		series = new XYSeries("singleton links");
+////		for(int i = 0; i <  clusterHeights.length - 2; i++) {
+////			if(i > 0 && i < clusterHeights.length - 2 && yValuesByOrderedRowNames[i] != yValuesByOrderedRowNames[i + 1] && yValuesByOrderedRowNames[i] != yValuesByOrderedRowNames[i - 1]) {
+////				series.add(i, yValuesByOrderedRowNames[i]);
+////				series.add(i + 1.5, yValuesByOrderedRowNames[i]);
+////				series.add(i + 1.5, yValuesByOrderedRowNames[i + 1]);
+////				series.add(i + 1.5, null);
+////			}
+////		}
+////		dataset2.addSeries(series);
+//
+//
+////		// Other clusters
+////		ArrayList<Double> otherClusters = new ArrayList<Double>();
+////		//series = new XYSeries("other clusters");
+////		for(int i = 0; i < clusterHeights.length; i++) {
+////			// If not a leaf
+////			boolean done = false;
+////			for(int j = 0; j < clusterNumbersValuesByOrderedRowNames.length; j++) {
+////				if(clusterHeights[i] == yValuesByOrderedRowNames[j])	{
+////					done = true;
+////					break;
+////				}
+////			}
+////			if(done)	{
+////				continue;
+////			}
+////			System.err.println("JFCChartsEngine.createCAH2dChart() other clusters: " + new DecimalFormat("0.0000000000000000").format(clusterHeights[i]));
+////		}
+////		//dataset2.addSeries(series);
+//
+//
+//
+////		dataset.addValue(0, "test", "truc 1");
+////		dataset.addValue(0.5, "test", "truc 1");
+////		dataset.addValue(0.9, "test", "truc 1");
+//		// Create the chart
+//        //chart = this.createXYBarChart(dataset2, title, xAxisLabel, "Height", false, false);
+//        chart = ChartFactory.createXYLineChart(
+//        		title,      // chart title
+//        		xAxisLabel,                      // x axis label
+//                "height",                      // y axis label
+//                dataset2,                  // data
+//                PlotOrientation.VERTICAL,
+//                true,                     // include legend
+//                true,                     // tooltips
+//                false                     // urls
+//            );
+//
+//
+//
+//
+//        chart.getXYPlot().setRenderer(this.theme.createXYLineAndShapeRenderer(true, false));
+//        ((IItemSelectionRenderer) chart.getXYPlot().getRenderer()).setChartType(ChartsEngine.CHART_TYPE_CAH_2D);
+//
+//
+//        //chart.getXYPlot().addAnnotation(new XYLineAnnotation(0.5,  yValuesByOrderedRowNames[0], 0.5,  yValuesByOrderedRowNames[0] + 0.002));
+//
+//
+//
+//
+//
+//
+//
+//
+//        //System.err.println("JFCChartsEngine.createCAH2dChart() " + chart.getCategoryPlot().getCategories().get(0));
+//        //chart.getCategoryPlot().addAnnotation(new CategoryLineAnnotation("1970-12-31", .0002, "1965-12-31", .00005, Color.red, new BasicStroke(2.0f)));
+//
+//        // Custom range axis for ticks drawing options
+//        //chart.getCategoryPlot().setRangeAxis(new ExtendedNumberAxis((NumberAxis) chart.getCategoryPlot().getRangeAxis(), false, true, 0, DatasetUtilities.findMaximumRangeValue(chart.getCategoryPlot().getDataset()).doubleValue()));
+//
+//
+//
+//		// Apply theme to the chart
+//		this.theme.apply(chart);
+//
+//
+//
+//		// FIXME: test algo R
+//		int dimens = 2;
+//		int ax1 = 0;
+//		int ax2 = 1;
+//		double x1, y1, x2, y2, w1, w2;
+//
+//		double h1, h2; // FIXME: when using 3 dimensions
+//
+//
+//		double[][] aa = new double[clusterMerges.length][4];
+//		for(int i = 0; i < clusterMerges.length; i++) {
+//			for(int j = 0; j < 4; j++) {
+//				aa[i][j] = 0;
+//			}
+//		}
+//
+//
+//		   //aa=matrix(ncol=4, nrow=nrow(merge))
+//
+//
+//
+//
+//		// Decrement/increment the cluster merge value because the R algorithm uses 1 as first table index
+//
+//		for(int i = 0; i < clusterMerges.length; i++) {
+//			if(clusterMerges[i][0] < 0)	{
+//				clusterMerges[i][0]++;
+//			}
+//			else	{
+//				clusterMerges[i][0]--;
+//			}
+//
+//			if(clusterMerges[i][1] < 0)	{
+//				clusterMerges[i][1]++;
+//			}
+//			else	{
+//				clusterMerges[i][1]--;
+//			}
+//		}
+//
+//
+//		for(int i = 0; i < clusterMerges.length; i++) {
+//
+////		    for(i in 1:nrow(merge)){
+//			     // if(merge[i,1]<0){
+//			// Singleton
+//			if(clusterMerges[i][0] < 0)	{
+//
+//
+//			        x1 = clusterCoords[(int) -clusterMerges[i][0]][ax1];
+//			        y1 = clusterCoords[(int) -clusterMerges[i][0]][ax2];
+//
+//
+//			        h1 = 0;
+//			        w1 = 1;
+//			      }
+//			      else{
+//			        x1 = aa[(int) clusterMerges[i][0]][0];
+//			        y1 = aa[(int) clusterMerges[i][0]][1];
+//			        w1 = aa[(int) clusterMerges[i][0]][3];
+//			        h1 = aa[(int) clusterMerges[i][0]][2];
+//			      }
+//			// Singleton
+//			if(clusterMerges[i][1] < 0)	{
+//			      //if(merge[i,2]<0){
+//			        x2 = clusterCoords[-(int) clusterMerges[i][1]][ax1];
+//			        y2 = clusterCoords[-(int) clusterMerges[i][1]][ax2];
+//			        h2 = 0;
+//			        w2 = 1;
+//			      }
+//			      else{
+//			        x2 = aa[(int) clusterMerges[i][1]][0];
+//			        y2 = aa[(int) clusterMerges[i][1]][1];
+//			        w2 = aa[(int) clusterMerges[i][1]][3];
+//			        h2 = aa[(int) clusterMerges[i][1]][2];
+//			      }
+//			      aa[i][0] = (w1 * x1 + w2 * x2) / (w1 + w2);
+//			      aa[i][1] = (w1 * y1 + w2 * y2) / (w1 + w2);
+//
+//			      //if(i<=nrow(merge)-t.level+1)
+//			      if(i <= clusterMerges.length)	{
+//			    	  clusterHeights[i] = 0;
+//			      }
+//
+//			      aa[i][2] = clusterHeights[i];
+//			      aa[i][3] = w1 + w2;
+//
+////			      if(i>(nrow(merge)-t.level+1)){
+////			      if(i > clusterMerges[i][1]){ // FIXME: this test is strange
+////			        if(dimens==3) s$points3d(rbind(c(x1,y1,h1),c(x1,y1,height[i]), c(x2,y2,height[i]),c(x2,y2,h2)), lty=1, type="o", pch="")
+//			        if(dimens == 2)	{
+//			        //	lines(c(x1,x2), c(y1,y2), lwd=(height[i]/max(height))*3)
+//
+//			        	//chart.getXYPlot().addAnnotation(new XYLineAnnotation(x1, y1, x2, y2));
+//			        	// tests with steps lines
+//			        	x1 *= 10;
+//			        	x2 *= 10;
+//			        	y1 /= 100;
+//			        	y2 /= 100;
+//
+//			        	chart.getXYPlot().addAnnotation(new XYLineAnnotation(x1, y1, x1, y2));
+//			        	chart.getXYPlot().addAnnotation(new XYLineAnnotation(x1, y2, x2, y2));
+//			        	chart.getXYPlot().addAnnotation(new XYLineAnnotation(x2, y2, x2, y1));
+//
+//
+//			        	// FIXME: labels tests
+//			        	chart.getXYPlot().addAnnotation(new XYTextAnnotation(rowNames[(int) Math.abs(clusterMerges[i][0])], x1, y1));
+//			        	chart.getXYPlot().addAnnotation(new XYTextAnnotation(rowNames[(int) Math.abs(clusterMerges[i][1])], x2, y1));
+//
+//
+//
+////			        	chart.getXYPlot().addAnnotation(new XYLineAnnotation(y2, x1, y1, x1));
+//
+//
+//			        	//chart.getXYPlot().addAnnotation(new XYLineAnnotation(x2, y2, x2, y2));
+//
+//
+//			        	System.err.println("JFCChartsEngine.createCAH2dChart(): draw line " + x1 + ", " + y1 + " | " + x2 + "," + y2);
+//			        }
+////			      }
+//		//	    }
+//
+//
+//		}
+//
+//
+//		// FIXME: test symbol axis
+//		//chart.getXYPlot().setDomainAxis(new SymbolAxis("test symbol axis", new String[]{"A", "b", "c"}));
+//
+//		// FIXME: for cluster boxes we may use XYBoxAnnotation()
+//
+//
+//		//chart.getXYPlot().addAnnotation(new XYLineAnnotation(x1, y1, x2, y2));
+//
+//
+//        return chart;
+//
+//	}
 
+	// FIXME: new version with category step renderer
+//	@Override
+//	public JFreeChart createCAH2dChart(CAH cah) {
+//
+//
+//			JFreeChart chart = null;
+//
+//			// Creating the data set from the result
+//			DefaultCategoryDataset dataset = new DefaultCategoryDataset();
+//			String category = "cluster ";
+//
+//
+//
+//			int[] clusterNumbers = cah.getClusterNumbers();
+//			String[] rowNames = cah.getClusterRowNames();
+//			String[] orderedRowNames = cah.getClusterOrderedRowNames();
+//			double[] clusterHeights = cah.getClusterTreeHeights();
+//			double[][] clusterMerge = cah.getClusterTreeMerges();
+//
+//
+//			double[] yValuesByOrderedRowNames = new double[rowNames.length];
+//			double[] clusterNumbersValuesByOrderedRowNames = new double[rowNames.length];
+//
+//
+//
+//			// FIXME: Sort the cluster numbers in reverse order
+////			Arrays.sort(clusterNumbers);
+////			ArrayUtils.reverse(clusterNumbers);
+////			System.out.println(Arrays.toString(clusterNumbers));
+//
+//
+//			// FIXME: tests row names
+//			//System.err.println("JFCChartsEngine.createCAH2dChart(): cluster row names: \t\t" + Arrays.toString(rowNames));
+//
+//			// FIXME: tests ordered row names
+//			//System.err.println("JFCChartsEngine.createCAH2dChart(): cluster ordered row names: \t" + Arrays.toString(orderedRowNames));
+//
+//			// FIXME: tests, ordered cluster numbers
+//			//System.err.println("JFCChartsEngine.createCAH2dChart(): cluster number: \t\t" + Arrays.toString(clusterNumbers));
+//
+//
+//
+//			for (int i = 0 ; i < clusterMerge.length ; i++) {
+//
+//				// Singleton
+//				if(clusterMerge[i][0] < 0)	{
+//
+//					//System.err.print("JFCChartsEngine.createCAH2dChart(): merging: " + rowNames[(int) Math.abs(clusterMerge[i][0]) - 1]);
+//
+//					// Put the height in the ordered by names values table
+//					for(int j = 0; j < orderedRowNames.length; j++) {
+//						if(orderedRowNames[j].equals(rowNames[(int) Math.abs(clusterMerge[i][0]) - 1]))	{
+//							yValuesByOrderedRowNames[j] = clusterHeights[i];
+//							//clusterNumbersValuesByOrderedRowNames[j] = clusterNumbers[(int) Math.abs(clusterMerge[i][0]) - 1];
+//						}
+//					}
+//
+//				}
+//				// Non-singleton
+//				else	{
+//					//System.err.print("JFCChartsEngine.createCAH2dChart(): merging aggregation: " +  clusterMerge[i][0]);
+//				}
+//
+//				// Singleton
+//				if(clusterMerge[i][1] < 0)	{
+//					//System.err.print(" with: " + rowNames[(int) Math.abs(clusterMerge[i][1]) - 1]);
+//
+//					// Put the height in the ordered by names values table
+//					for(int j = 0; j < orderedRowNames.length; j++) {
+//						if(orderedRowNames[j].equals(rowNames[(int) Math.abs(clusterMerge[i][1]) - 1]))	{
+//							yValuesByOrderedRowNames[j] = clusterHeights[i];
+//							//clusterNumbersValuesByOrderedRowNames[j] = clusterNumbers[(int) Math.abs(clusterMerge[i][1]) - 1];
+//						}
+//
+//					}
+//
+//				}
+//				// Non-singleton
+//				else	{
+//					//System.err.print(" with aggregation: " + clusterMerge[i][1]);
+//				}
+//
+//				//System.err.println(" and height: " + clusterHeights[i] + " as aggregation: " + (i + 1));
+//
+//			}
+//
+//
+//			// Create the data set
+//
+//			for(int i = 0; i < yValuesByOrderedRowNames.length; i++) {
+//				//dataset.setValue(yValuesByOrderedRowNames[i], category + clusterNumbers[clusterNumbers.length - 1 - i], orderedRowNames[i]);
+//
+//				dataset.setValue(yValuesByOrderedRowNames[i], category + clusterNumbers[yValuesByOrderedRowNames.length - 1 - i], orderedRowNames[i]);
+//				//dataset.setValue(yValuesByOrderedRowNames[i], category, orderedRowNames[i]);
+//
+//				//dataset.setValue(yValuesByOrderedRowNames[i], category + clusterNumbersValuesByOrderedRowNames[i], orderedRowNames[i]);
+//			}
+//
+////
+////			for (int i = 0 ; i <  cah.getClusterTreeMerges().length; i++) {
+////				System.err.println("JFCChartsEngine.createCAH2dChart() merges : ");
+////				for(int j = 0; j < cah.getClusterTreeMerges()[i].length; j++) {
+////					System.err.print(" : " + cah.getClusterTreeMerges()[i][j]);
+////				}
+////			}
+//
+//
+//
+////			ArrayList<Double> middlePoints = cah.getClusterTreeMiddlePoints();
+////
+////			for (int i = 0 ; i <  middlePoints.size(); i++) {
+////				System.err.println("JFCChartsEngine.createCAH2dChart() middle points X: " + middlePoints.get(i));
+////			}
+//
+//
+//
+////			for (int i = 0 ; i < cah.getClusterCoords().length ; i++) {
+////				for(int j = 0; j < cah.getClusterCoords()[i].length; j++) {
+////					//System.err.println("JFCChartsEngine.createCAH2dChart(): " + cah.getClusterCoords()[i][j]);
+////					dataset.setValue(cah.getClusterCoords()[i][j], category + clusterNumbers[i], rownames[i]);
+////				}
+////			}
+//
+//
+//
+//			// Create chart title
+//			String title = "title";
+//			String xAxisLabel = "Column";
+//			if(!cah.isColumnsComputing())	{
+//				xAxisLabel = "Row";
+//			}
+//
+//
+//			// Create the chart
+//	        chart = this.createCategoryStepChart(dataset, title, xAxisLabel, "Height", false, false);
+//
+//
+//	        ((IItemSelectionRenderer) chart.getCategoryPlot().getRenderer()).setChartType(ChartsEngine.CHART_TYPE_CAH_2D);
+//
+//
+//	        // Draw tree
+//	        chart.getCategoryPlot().addAnnotation(new CategoryLineAnnotation(chart.getCategoryPlot().getDataset().getColumnKey(0), 5.0,
+//	        		chart.getCategoryPlot().getDataset().getColumnKey(1), 8.0, Color.red, new BasicStroke(2.0f)));
+//
+//	        // Custom range axis for ticks drawing options: cut the range to minimum and maximum values
+//	        chart.getCategoryPlot().setRangeAxis(new ExtendedNumberAxis((NumberAxis) chart.getCategoryPlot().getRangeAxis(), false, true, 0, DatasetUtilities.findMaximumRangeValue(chart.getCategoryPlot().getDataset()).doubleValue()));
+//
+//
+//		return chart;
+//
+//
+//
+//
+//	}
 	
 
+
+	
+
 }
Index: tmp/org.txm.cah.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.cah.core/META-INF/MANIFEST.MF	(revision 136)
+++ tmp/org.txm.cah.core/META-INF/MANIFEST.MF	(revision 137)
@@ -1,10 +1,9 @@
 Manifest-Version: 1.0
 Bundle-ManifestVersion: 2
-Bundle-Name: CAH TBX
+Bundle-Name: CAH Core
 Bundle-SymbolicName: org.txm.cah.core;singleton:=true
 Bundle-Version: 1.0.0.qualifier
-Bundle-Activator: org.txm.cah.core.Activator
-Require-Bundle: org.eclipse.ui,
+Require-Bundle: org.txm.ca.core;bundle-version="1.0.0",
  org.eclipse.core.runtime,
  org.txm.core;bundle-version="0.7.0",
  org.txm.chartsengine.core;bundle-version="1.0.0",
@@ -12,8 +11,7 @@
  org.txm.chartsengine.jfreechart.core;bundle-version="1.0.0"
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
 Bundle-ActivationPolicy: lazy
-Export-Package: org.txm.cah.core,
- org.txm.cah.core.chartsengine.jfreechart,
+Export-Package: org.txm.cah.core.chartsengine.jfreechart,
  org.txm.cah.core.chartsengine.r,
  org.txm.cah.core.functions,
  org.txm.cah.core.messages,
Index: tmp/org.txm.core/src/java/org/txm/Toolbox.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 136)
+++ tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 137)
@@ -43,16 +43,14 @@
 import java.util.logging.Level;
 
 import org.apache.commons.lang.StringUtils;
+import org.txm.ca.core.functions.CA;
 import org.txm.chartsengine.core.ChartsEngine;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
-import org.txm.core.chartsengine.base.___ChartsEngine;
 import org.txm.core.preferences.TXMPreferences;
-import org.txm.functions.ca.CA;
-import org.txm.functions.progression.Progression;
-import org.txm.functions.specificities.SpecificitesResult;
 import org.txm.importer.cwb.PatchCwbRegistry;
 import org.txm.objects.Base;
 import org.txm.objects.Workspace;
+import org.txm.progression.core.functions.Progression;
 import org.txm.searchengine.cqp.AbstractCqiClient;
 import org.txm.searchengine.cqp.AbstractCqiServer;
 import org.txm.searchengine.cqp.MemCqiClient;
@@ -64,6 +62,7 @@
 import org.txm.searchengine.cqp.corpus.CorpusManager;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.corpus.Partition;
+import org.txm.specificities.core.functions.SpecificitesResult;
 import org.txm.stat.data.LexicalTable;
 import org.txm.stat.engine.r.RWorkspace;
 import org.txm.stat.engine.r.RWorkspaceException;
@@ -538,7 +537,7 @@
 			properties = props;
 
 			// FIXME: Set charts engine default properties
-			___ChartsEngine.initDefaultProperties(props);
+			//___ChartsEngine.initDefaultProperties(props);
 
 			// initialize workspace : list of corpus loaded in TXM
 			stateWorkspace = startWorkspace();
Index: tmp/org.txm.core/src/java/org/txm/functions/contrasts/Contrast.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/functions/contrasts/Contrast.java	(revision 136)
+++ tmp/org.txm.core/src/java/org/txm/functions/contrasts/Contrast.java	(revision 137)
@@ -8,9 +8,8 @@
 import java.io.UnsupportedEncodingException;
 
 import org.txm.Messages;
-import org.txm.core.chartsengine.r.__RDevice;
 import org.txm.functions.TXMResult;
-import org.txm.functions.progression.Progression;
+import org.txm.progression.core.functions.Progression;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Lexicon;
@@ -19,12 +18,10 @@
 import org.txm.searchengine.cqp.corpus.Subcorpus;
 import org.txm.stat.StatException;
 import org.txm.stat.data.LexicalTable;
-import org.txm.stat.data.Matrix;
 import org.txm.stat.data.Vector;
+import org.txm.stat.engine.r.RDevice;
 import org.txm.stat.engine.r.RWorkspace;
-import org.txm.stat.engine.r.data.DoubleMatrix;
 import org.txm.stat.engine.r.data.LexicalTableImpl;
-import org.txm.stat.engine.r.data.VectorImpl;
 
 public abstract class Contrast  implements TXMResult {
 
@@ -170,8 +167,10 @@
 	 * @param device the device
 	 * @throws StatException the stat exception
 	 */
+	// FIXME: should be manage by the charts engine
+	@Deprecated
 	public final void toSVG(File file, String[] typeNames,
-			String[] partNames, double[][] specIndex, boolean transpose, boolean drawBarPlot, boolean drawLines, __RDevice device, int BANALITE, boolean monochrome) throws StatException {
+			String[] partNames, double[][] specIndex, boolean transpose, boolean drawBarPlot, boolean drawLines, RDevice device, int BANALITE, boolean monochrome) throws StatException {
 
 		RWorkspace rw = RWorkspace.getRWorkspaceInstance();
 		try {
Index: tmp/org.txm.core/src/java/org/txm/functions/contrasts/Contrasts.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/functions/contrasts/Contrasts.java	(revision 136)
+++ tmp/org.txm.core/src/java/org/txm/functions/contrasts/Contrasts.java	(revision 137)
@@ -3,8 +3,8 @@
 import java.util.ArrayList;
 
 import org.txm.Messages;
-import org.txm.functions.specificities.Chi2;
-import org.txm.functions.specificities.Specificites2;
+import org.txm.specificities.core.functions.Chi2;
+import org.txm.specificities.core.functions.Specificites2;
 import org.txm.stat.data.LexicalTable;
 
 public class Contrasts {
Index: tmp/org.txm.core/src/java/org/txm/functions/cooccurrences/Cooccurrence.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/functions/cooccurrences/Cooccurrence.java	(revision 136)
+++ tmp/org.txm.core/src/java/org/txm/functions/cooccurrences/Cooccurrence.java	(revision 137)
@@ -50,8 +50,6 @@
 import org.txm.functions.concordances.Line;
 import org.txm.functions.cooccurrences.comparators.CLineComparator;
 import org.txm.functions.index.Index;
-import org.txm.functions.specificities.Specificites;
-import org.txm.functions.specificities.SpecificitesResult;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
 import org.txm.searchengine.cqp.corpus.Corpus;
@@ -62,6 +60,8 @@
 import org.txm.searchengine.cqp.corpus.query.Match;
 import org.txm.searchengine.cqp.corpus.query.Query;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
+import org.txm.specificities.core.functions.Specificites;
+import org.txm.specificities.core.functions.SpecificitesResult;
 import org.txm.stat.StatException;
 import org.txm.stat.data.LexicalTable;
 import org.txm.stat.engine.r.RWorkspace;
